// Code generated by ent, DO NOT EDIT.

package ent

import (
	"fmt"
	"strings"
	"time"

	"entgo.io/ent/dialect/sql"
	"github.com/google/uuid"
	"gitlab.com/pajaziti.bersen/agorus-ent/ent/item"
	"gitlab.com/pajaziti.bersen/agorus-ent/ent/itemmeta"
)

// ItemMeta is the model entity for the ItemMeta schema.
type ItemMeta struct {
	config `json:"-"`
	// ID of the ent.
	ID uuid.UUID `json:"id,omitempty"`
	// Key holds the value of the "key" field.
	Key string `json:"key,omitempty"`
	// Value holds the value of the "value" field.
	Value string `json:"value,omitempty"`
	// CreatedAt holds the value of the "created_at" field.
	CreatedAt time.Time `json:"created_at,omitempty"`
	// UpdatedAt holds the value of the "updated_at" field.
	UpdatedAt time.Time `json:"updated_at,omitempty"`
	// ItemID holds the value of the "item_id" field.
	ItemID uuid.UUID `json:"item_id,omitempty"`
	// MetafilterID holds the value of the "metafilter_id" field.
	MetafilterID uuid.UUID `json:"metafilter_id,omitempty"`
	// Edges holds the relations/edges for other nodes in the graph.
	// The values are being populated by the ItemMetaQuery when eager-loading is set.
	Edges ItemMetaEdges `json:"edges"`
}

// ItemMetaEdges holds the relations/edges for other nodes in the graph.
type ItemMetaEdges struct {
	// Item holds the value of the item edge.
	Item *Item `json:"item,omitempty"`
	// loadedTypes holds the information for reporting if a
	// type was loaded (or requested) in eager-loading or not.
	loadedTypes [1]bool
}

// ItemOrErr returns the Item value or an error if the edge
// was not loaded in eager-loading, or loaded but was not found.
func (e ItemMetaEdges) ItemOrErr() (*Item, error) {
	if e.loadedTypes[0] {
		if e.Item == nil {
			// The edge item was loaded in eager-loading,
			// but was not found.
			return nil, &NotFoundError{label: item.Label}
		}
		return e.Item, nil
	}
	return nil, &NotLoadedError{edge: "item"}
}

// scanValues returns the types for scanning values from sql.Rows.
func (*ItemMeta) scanValues(columns []string) ([]interface{}, error) {
	values := make([]interface{}, len(columns))
	for i := range columns {
		switch columns[i] {
		case itemmeta.FieldKey, itemmeta.FieldValue:
			values[i] = new(sql.NullString)
		case itemmeta.FieldCreatedAt, itemmeta.FieldUpdatedAt:
			values[i] = new(sql.NullTime)
		case itemmeta.FieldID, itemmeta.FieldItemID, itemmeta.FieldMetafilterID:
			values[i] = new(uuid.UUID)
		default:
			return nil, fmt.Errorf("unexpected column %q for type ItemMeta", columns[i])
		}
	}
	return values, nil
}

// assignValues assigns the values that were returned from sql.Rows (after scanning)
// to the ItemMeta fields.
func (im *ItemMeta) assignValues(columns []string, values []interface{}) error {
	if m, n := len(values), len(columns); m < n {
		return fmt.Errorf("mismatch number of scan values: %d != %d", m, n)
	}
	for i := range columns {
		switch columns[i] {
		case itemmeta.FieldID:
			if value, ok := values[i].(*uuid.UUID); !ok {
				return fmt.Errorf("unexpected type %T for field id", values[i])
			} else if value != nil {
				im.ID = *value
			}
		case itemmeta.FieldKey:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field key", values[i])
			} else if value.Valid {
				im.Key = value.String
			}
		case itemmeta.FieldValue:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field value", values[i])
			} else if value.Valid {
				im.Value = value.String
			}
		case itemmeta.FieldCreatedAt:
			if value, ok := values[i].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field created_at", values[i])
			} else if value.Valid {
				im.CreatedAt = value.Time
			}
		case itemmeta.FieldUpdatedAt:
			if value, ok := values[i].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field updated_at", values[i])
			} else if value.Valid {
				im.UpdatedAt = value.Time
			}
		case itemmeta.FieldItemID:
			if value, ok := values[i].(*uuid.UUID); !ok {
				return fmt.Errorf("unexpected type %T for field item_id", values[i])
			} else if value != nil {
				im.ItemID = *value
			}
		case itemmeta.FieldMetafilterID:
			if value, ok := values[i].(*uuid.UUID); !ok {
				return fmt.Errorf("unexpected type %T for field metafilter_id", values[i])
			} else if value != nil {
				im.MetafilterID = *value
			}
		}
	}
	return nil
}

// QueryItem queries the "item" edge of the ItemMeta entity.
func (im *ItemMeta) QueryItem() *ItemQuery {
	return (&ItemMetaClient{config: im.config}).QueryItem(im)
}

// Update returns a builder for updating this ItemMeta.
// Note that you need to call ItemMeta.Unwrap() before calling this method if this ItemMeta
// was returned from a transaction, and the transaction was committed or rolled back.
func (im *ItemMeta) Update() *ItemMetaUpdateOne {
	return (&ItemMetaClient{config: im.config}).UpdateOne(im)
}

// Unwrap unwraps the ItemMeta entity that was returned from a transaction after it was closed,
// so that all future queries will be executed through the driver which created the transaction.
func (im *ItemMeta) Unwrap() *ItemMeta {
	_tx, ok := im.config.driver.(*txDriver)
	if !ok {
		panic("ent: ItemMeta is not a transactional entity")
	}
	im.config.driver = _tx.drv
	return im
}

// String implements the fmt.Stringer.
func (im *ItemMeta) String() string {
	var builder strings.Builder
	builder.WriteString("ItemMeta(")
	builder.WriteString(fmt.Sprintf("id=%v, ", im.ID))
	builder.WriteString("key=")
	builder.WriteString(im.Key)
	builder.WriteString(", ")
	builder.WriteString("value=")
	builder.WriteString(im.Value)
	builder.WriteString(", ")
	builder.WriteString("created_at=")
	builder.WriteString(im.CreatedAt.Format(time.ANSIC))
	builder.WriteString(", ")
	builder.WriteString("updated_at=")
	builder.WriteString(im.UpdatedAt.Format(time.ANSIC))
	builder.WriteString(", ")
	builder.WriteString("item_id=")
	builder.WriteString(fmt.Sprintf("%v", im.ItemID))
	builder.WriteString(", ")
	builder.WriteString("metafilter_id=")
	builder.WriteString(fmt.Sprintf("%v", im.MetafilterID))
	builder.WriteByte(')')
	return builder.String()
}

// ItemMetaSlice is a parsable slice of ItemMeta.
type ItemMetaSlice []*ItemMeta

func (im ItemMetaSlice) config(cfg config) {
	for _i := range im {
		im[_i].config = cfg
	}
}
